// ReleaseWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ReleaseWnd.h"
#include "HttpDownloadDlg.h"
#include "otherfunctions.h"
#include "ini2.h"

// CReleaseWnd dialog

IMPLEMENT_DYNAMIC(CReleaseWnd, CDialog)
CReleaseWnd::CReleaseWnd(CWnd* pParent)
: CResizableDialog(CReleaseWnd::IDD, pParent)
{
}

CReleaseWnd::~CReleaseWnd()
{
}

BOOL CReleaseWnd::OnInitDialog(){
	CDialog::OnInitDialog();
	AddAnchor(IDC_RELEASES,TOP_LEFT,BOTTOM_RIGHT);
	CListCtrl* list = (CListCtrl*)GetDlgItem(IDC_RELEASES);
	list->SetExtendedStyle(LVS_EX_FULLROWSELECT);
	list->InsertColumn(0, "Site", LVCFMT_LEFT, 130, 0);
	list->InsertColumn(1, "Release", LVCFMT_LEFT, 460, 1);
	list->InsertColumn(2, "Link", LVCFMT_LEFT, 460, 2);
	list->InsertItem(0, "");
	list->SetItemText(0, 1, "If you leave the URL blank, it will default to sharereactor's site!!");
	list->InsertItem(1, "");
	list->SetItemText(1, 1, "If you add a url, you must add http:// or ftp:// at the begining or else it wont work");
	list->InsertItem(2, "");
	list->SetItemText(2, 1, "Please don't hammer the sites with Get New Releases requests every few minutes, use it wisely.");
	list->InsertItem(3, "");
	list->SetItemText(3, 1, "Added a \"New Window\" Option at top, that will open a new browser each click (Will Work only with Internet Explorer).");
	LoadSiteList();
	return true;
}

void CReleaseWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CReleaseWnd, CResizableDialog)
	ON_BN_CLICKED(IDC_BN_GETRELEASES, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BN_THISSITE, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BN_DELETESITE, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BN_ADDSITE, OnBnClickedButton4)
	ON_NOTIFY(NM_DBLCLK, IDC_RELEASES, OnReleaseListclick)
END_MESSAGE_MAP()

void CReleaseWnd::OnReleaseListclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	CListCtrl* list = (CListCtrl*)GetDlgItem(IDC_RELEASES);
	int selItem = list->GetSelectionMark(); 
	if (selItem > -1)
	{
		CString relLink = list->GetItemText(selItem, 2);
		if ((relLink.Left(7) == "http://") || (relLink.Left(6) == "ftp://"))
		{
			if (this->IsDlgButtonChecked(IDC_NEWWIN))
			{
				ShellExecute(NULL, "open", "iexplore.exe", relLink, NULL, SW_SHOW); 
			}
			else
				ShellExecute(NULL, "open", relLink, NULL, NULL, SW_SHOW);
		}
		else if (relLink.Left(10) == "addlink://")
		{
			AddRelease(relLink.Mid(10));
		}
		else
			theApp.emuledlg->AddLogLine(true, "The clicked URL is invalid.");
	}
}

void CReleaseWnd::UpdateReleaseList(CString strFileName, CString SiteName)
{
	CStdioFile f;
	CString strLine, strTitle, strLink;
	//CString strFilename = "releases.rdf";
	CListCtrl* list = (CListCtrl*)GetDlgItem(IDC_RELEASES);
	int initem=0,intitle=0,inlink=0,alreadyshowed=0;

	if (!f.Open(strFileName, CFile::modeRead | CFile::typeText))
		return;	
	while(f.ReadString(strLine)) {
		int i;
		strLine.Replace("&lt;","<");
		strLine.Replace("&gt;",">");
		if (strLine.Find("<item>") > -1)
		{
			alreadyshowed=0;
			initem=1;
		}
		if (initem)
		{
			if ((i=strLine.Find("<title>")) > -1)
			{
				strTitle = strLine.Mid(i+7);
				if ((i=strTitle.Find("</title")) > -1)
					strTitle = strTitle.Left(i);
			}
			if ((i=strLine.Find("<link>")) > -1)
			{
				strLink = strLine.Mid(i+6);
				if ((i=strLink.Find("</link")) > -1)
					strLink = strLink.Left(i);
			}
			if (strLine.Find("</item>") > -1)
				initem=0;
		}
		if (!alreadyshowed && !initem && (strTitle.GetLength() > 0) && (strLink.GetLength() > 0))
		{
			alreadyshowed=1;
			strTitle.Replace("&#38;","&");
			strTitle.Replace("&38;","&");
			strTitle.Replace("&038;","&");
			strTitle.Replace("&#39;","'");
			strTitle.Replace("&39;","'");
			strTitle.Replace("&039;","'");
			strTitle.Replace("&amp;","&");
			strTitle.Replace("&quot;","\"");
			strTitle.Replace("&lt;","<");
			strTitle.Replace("&gt;",">");
			strTitle.Replace("\r","");
			strTitle.Replace("\n","");
			strLink.Replace("\r","");
			strLink.Replace("\n","");
			if (strTitle.Find("resented by") == -1)
			{
				list->InsertItem(list->GetItemCount(), SiteName.Trim());
				list->SetItemText(list->GetItemCount()-1, 1, (LPCTSTR)strTitle.Trim());
				list->SetItemText(list->GetItemCount()-1, 2, (LPCTSTR)strLink.Trim());
			}
		}
	}
	f.Close();
}

int CReleaseWnd::ConnectToSite(CString URL)
{
	return 0;
}

void CReleaseWnd::OnBnClickedButton1()
{
	CString strURL;
	CString strTempFilename;
	CComboBox* list = (CComboBox*)GetDlgItem(IDC_RELURL);
	CListCtrl* listRelease = (CListCtrl*)GetDlgItem(IDC_RELEASES);
	int countRelease;

	strTempFilename.Format("%sreleases.rdf", theApp.glob_prefs->GetConfigDir());
	if (list->GetCount() == 0)
	{
		AddRelease("http://www.sharereactor.com/sharereactor.rdf");
		AddRelease("http://www.geeklog.net/backend/geeklog.rdf");
		AddRelease("http://theblackhand.sourceforge.net/updates.rdf");

		list->SetCurSel(0);
	}
	GetDlgItem(IDC_RELURL)->GetWindowText(strURL);
	int doonce=1;
	for (int i = 0 ; i < list->GetCount() ; i ++)
	{
		list->GetLBText(i, strURL);
		if (strURL.GetLength()<1)
		{
			strURL = "http://theblackhand.sourceforge.net/updates.rdf";
			GetDlgItem(IDC_RELURL)->SetWindowText(strURL);
		}
		if (strURL.Find("://") == -1)
		{
			theApp.emuledlg->AddLogLine(true, GetResString(IDS_INVALIDURL) );
			return;
		}
		CHttpDownloadDlg dlgDownload;
		dlgDownload.m_sURLToDownload = strURL;
		dlgDownload.m_sFileToDownloadInto = strTempFilename;
		if (dlgDownload.DoModal() != IDOK)
		{
			theApp.emuledlg->AddLogLine(true, GetResString(IDS_ERR_FAILEDDOWNLOADMET), strURL);
		}
		else
		{
			if (doonce==1) {listRelease->DeleteAllItems();doonce=0;}
			//CString SiteName, SiteName1;
			CString SiteName;
			SiteName = strURL.Mid(strURL.Find("://")+3);
			//SiteName1 = SiteName.Left(SiteName.Find("/"));
			countRelease = listRelease->GetItemCount();
			UpdateReleaseList(strTempFilename, SiteName);
			if ((listRelease->GetItemCount() > countRelease) && (i < list->GetCount()-1))
				listRelease->InsertItem(listRelease->GetItemCount(), "----------");
			remove(strTempFilename);
		}
	}
}

void CReleaseWnd::OnBnClickedButton2()
{
	CString strURL;
	CString strTempFilename;

	strTempFilename.Format("%sreleases.rdf", theApp.glob_prefs->GetConfigDir());
	GetDlgItem(IDC_RELURL)->GetWindowText(strURL);
	if (strURL.Find("://") == -1)
	{
		theApp.emuledlg->AddLogLine(true, GetResString(IDS_INVALIDURL) );
		return;
	}
	CHttpDownloadDlg dlgDownload;
	dlgDownload.m_sURLToDownload = strURL;
	dlgDownload.m_sFileToDownloadInto = strTempFilename;
	if (dlgDownload.DoModal() != IDOK)
	{
		theApp.emuledlg->AddLogLine(true, GetResString(IDS_ERR_FAILEDDOWNLOADMET), strURL);
	}
	else
	{
		CListCtrl* list = (CListCtrl*)GetDlgItem(IDC_RELEASES);
		list->DeleteAllItems();
		//CString SiteName, SiteName1;
		CString SiteName;
		SiteName = strURL.Mid(strURL.Find("://")+3);
		//SiteName1 = SiteName.Left(strURL.Find("/"));
		UpdateReleaseList(strTempFilename, SiteName);
		remove(strTempFilename);
	}
}

void CReleaseWnd::OnBnClickedButton3()
{
	CComboBox* list = (CComboBox*)GetDlgItem(IDC_RELURL);
	list->DeleteString(list->GetCurSel());
	list->SetCurSel(0);
	SaveSiteList();
}

void CReleaseWnd::OnBnClickedButton4()
{
	CString strURL;
	CComboBox* list = (CComboBox*)GetDlgItem(IDC_RELURL);
	GetDlgItem(IDC_RELURL)->GetWindowText(strURL);
	if (strURL.Find("://") > -1)
	{
		list->AddString(strURL);
		SaveSiteList();
	}

}

void CReleaseWnd::LoadSiteList(void)
{
	CString strNumber ;
	CString strFriend ;
	CString strURL ;
	CComboBox* list = (CComboBox*)GetDlgItem(IDC_RELURL);
	char buffer[490];
	::GetModuleFileName(0, buffer, 490);
	LPTSTR pszFileName = _tcsrchr(buffer, '\\') + 1;
	*pszFileName = '\0';
	//SaveSiteList();
	//char* appdir = nstrdup(buffer);
	CIni friends_ini((theApp.glob_prefs->GetConfigDir() + CString("releases.ini")), "Releases") ;
	int iNumberOfFriends = friends_ini.GetInt("NumberOfURLs", 0, "Releases") ;
	if (iNumberOfFriends != 0)
	{
		for (int i = 0 ; i < iNumberOfFriends ; i ++)
		{
			strNumber.Format("%d", i) ;
			strFriend = friends_ini.GetString(((CString)"Release_" + strNumber), "", "Releases") ;
			if (strFriend.Trim() != "") AddRelease(strFriend);
		}
		list->GetLBText(0, strURL);
	}
	if (strURL == "")
	{
		AddRelease("http://www.sharereactor.com/sharereactor.rdf");
		AddRelease("http://www.geeklog.net/backend/geeklog.rdf");
		AddRelease("http://theblackhand.sourceforge.net/updates.rdf");
	}
	list->SetCurSel(0);
}

void CReleaseWnd::SaveSiteList(void)
{
	CString strNumber ;
	CString strFriend ;
	CString strURL ;
	CComboBox* list = (CComboBox*)GetDlgItem(IDC_RELURL);
	char buffer[490];
	::GetModuleFileName(0, buffer, 490);
	LPTSTR pszFileName = _tcsrchr(buffer, '\\') + 1;
	*pszFileName = '\0';
	//char* appdir = nstrdup(buffer);
	CIni friends_ini((theApp.glob_prefs->GetConfigDir() + CString("releases.ini")), "Releases") ;
	friends_ini.WriteInt("NumberOfURLs", list->GetCount(), "Releases");
	for (int i = 0 ; i < list->GetCount() ; i ++) {
		strNumber.Format("%d", i);
		list->GetLBText(i, strURL);
		if (strURL.Trim() != "") friends_ini.WriteString(((CString)"Release_" +strNumber), strURL.Trim(), "Releases");
	}
	list->SetCurSel(0);
}

void CReleaseWnd::AddRelease(CString release)
{
	CString strList;
	CComboBox* list = (CComboBox*)GetDlgItem(IDC_RELURL);
	for (int i = 0 ; i < list->GetCount() ; i ++)
	{
		list->GetLBText(i, strList);
		if (strList == release.Trim())
			return;
	}
	list->AddString(release.Trim());
}